Subject: Re: bug#58376: [PATCH] Set the PARENTS argument for language environments

From: Visuwesh <[email-masked]>
Date: Sun, 09 Oct 2022 20:36:16 +0530

[ஞாயிறு அக்டோபர் 09, 2022] Visuwesh wrote:

> [ஞாயிறு அக்டோபர் 09, 2022] Eli Zaretskii wrote:
>
>>> If I do something like:
>>> 
>>> (set-language-info-alist
>>>  "Kharoshthi" '((charset unicode)
>>>        (coding-system utf-8)
>>>        (coding-priority utf-8)
>>>        (input-method . "kharoshthi")
>>>                 (sample-text . "Kharoṣṭhī (𐨑𐨪𐨆𐨛𐨁) 𐨣𐨨𐨲𐨪𐨆 𐨐𐨪𐨅𐨨𐨁")
>>>        (documentation . "\
>>> Language environment for Gāndhārī, Sanskrit, and other languages
>>> using the Kharoṣṭhī script."))
>>>  '("Misc" "Indian"))
>>> 
>>> Then compile and open emacs -Q
>>> Now opening Options>Multilingual Environment>Set Language Environment>Indian
>>> It only has the Kharoshthi entry
>>> Options>Multilingual Environment>Set Language Environment>Misc now also has an Indian submenu with
>>> only Kharoshthi entry.
>>
>> Hmm...  Either we don't understand what PARENTS mean (could it mean
>> a
>> hierarchy of several menu levels?), or there is a bug.
>>
>> If you want to work on that, please do; otherwise I'll just install
>> your original patch.
>
> Attached patch puts the "Kharosthi" item in both Indian and Misc
> submenus without overwriting.
>
>
>
> The problem is that when looping, the variables setup-map and
> describe-map gets outdated and causes the overwrite.  The solution I
> came up with was to update them both to their default after each
> iteration.  This involved moving the keymap-setting forms to a
> separate
> function.

Hmm, I seethat the function can be cleaned up further.  I will do it
after my dinner.